﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart.Styles;

namespace SurfaceTest
{
    public partial class Form1 : Form
    {
        Steema.TeeChart.Styles.Surface surface;
        public Form1()
        {
            InitializeComponent();
                
             surface = new Surface(tChart1.Chart);
             InitializeChart();
        }
        private void InitializeChart()
        {
           
             Random rnd = new Random();
             surface.Pen.Visible = false;
           
             surface.UsePalette = false;
             surface.UseColorRange = true;
             surface.IrregularGrid = true;
             for (int x = 0; x < 50; x++)
             {
                 for (int z = 0; z < 100; z++)
                 {
                        surface.Add(x, rnd.Next(100), z);

                 }
             }
           surface.StartColor = Color.Blue;
           surface.MidColor = Color.Red;
           surface.EndColor = Color.Green;  

        }

        private void button1_Click(object sender, EventArgs e)
        {
            tChart1.AutoRepaint = false;
            TeeSmoothGrid3D.SmoothGrid3D(surface);
            surface.UsePalette = false;
            surface.UseColorRange = true;
            surface.FillGridIndex();
            tChart1.AutoRepaint = true;
            tChart1.Refresh();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            tChart1.ShowEditor();
        }
      
    }


}
public class TeeSmoothGrid3D
{
    public static void SmoothGrid3D(Steema.TeeChart.Styles.Custom3DGrid Series)
    {
        double tmpX, tmpY, tmpZ;
        int tmpNumX = Series.NumXValues;
        int tmpNumZ = Series.NumZValues;
       
        Series.BeginUpdate();
        Series.IrregularGrid = true;

        try
        {
            for (int x = 1; x < tmpNumX; ++x)
            {
                for (int z = 1; z < tmpNumZ; ++z)
                {
                    if (Series[x, z] != -1 && Series[x + 1, z] != -1 && Series[x, z + 1] != -1)
                    {
                        tmpX = (Series.XValues[Series[x, z]] + Series.XValues[Series[x + 1, z]]) * 0.5;
                        tmpZ = (Series.ZValues[Series[x, z]] + Series.ZValues[Series[x, z + 1]]) * 0.5;

                        tmpY = (Series.YValues[Series[x, z]]
                            + Series.YValues[Series[x + 1, z]]
                            + Series.YValues[Series[x, z]]
                            + Series.YValues[Series[x, z + 1]]) * 0.25;
                    
                        Series.Add(tmpX, tmpY, tmpZ);

                        Series.Add(Series.XValues[Series[x, z]],
                            (Series.YValues[Series[x, z]] + Series.YValues[Series[x, z + 1]]) * 0.5,
                            tmpZ);

                        Series.Add(tmpX,
                            (Series.YValues[Series[x, z]] + Series.YValues[Series[x + 1, z]]) * 0.5,
                            Series.ZValues[Series[x, z]]);
                    }
                }
                if (Series[x, tmpNumZ] != -1 && Series[x + 1, tmpNumZ] != -1)
                {
                    
                    Series.Add((Series.XValues[Series[x, tmpNumZ]] + Series.XValues[Series[x + 1, tmpNumZ]]) * 0.5,
                        (Series.YValues[Series[x, tmpNumZ]] + Series.YValues[Series[x + 1, tmpNumZ]]) * 0.5,
                        Series.ZValues[Series[x, tmpNumZ]]);
                }
            }

            for (int z = 1; z < tmpNumZ; ++z)
            {
                if (Series[tmpNumX, z] != -1 && Series[tmpNumX, z + 1] != -1)
                {
                   
                    Series.Add(Series.XValues[Series[tmpNumX, z]],
                        (Series.YValues[Series[tmpNumX, z]] + Series.YValues[Series[tmpNumX, z + 1]]) * 0.5,
                        (Series.ZValues[Series[tmpNumX, z]] + Series.ZValues[Series[tmpNumX, z + 1]]) * 0.5
                         );
                }
            }
        }
        catch (Exception ex)
        {

        }

        Series.EndUpdate();
        Series.RefreshSeries();
    }
}
